import React from 'react';
import { CytoScapeRenderer } from '../renderer/cytoscape/renderer';
import { ReactForceGraphRenderer } from '../renderer/react-force-graph/renderer';

var GraphVisualization = function GraphVisualization(_ref) {
  var _ref$renderer = _ref.renderer,
      renderer = _ref$renderer === void 0 ? "cytoscape" : _ref$renderer,
      _ref$data = _ref.data,
      data = _ref$data === void 0 ? undefined : _ref$data,
      _ref$layout = _ref.layout,
      layout = _ref$layout === void 0 ? 'euler' : _ref$layout,
      _ref$width = _ref.width,
      width = _ref$width === void 0 ? "100%" : _ref$width,
      _ref$height = _ref.height,
      height = _ref$height === void 0 ? "500px" : _ref$height,
      _ref$style = _ref.style,
      style = _ref$style === void 0 ? {} : _ref$style,
      _ref$interactions = _ref.interactions,
      interactions = _ref$interactions === void 0 ? {} : _ref$interactions,
      _ref$schema = _ref.schema,
      schema = _ref$schema === void 0 ? {} : _ref$schema,
      _ref$showNavigator = _ref.showNavigator,
      showNavigator = _ref$showNavigator === void 0 ? false : _ref$showNavigator,
      graphqlUrl = _ref.graphqlUrl,
      graphqlQuery = _ref.graphqlQuery;

  // TODO: Do the retrieving and parsing of graphql queries here instead of in the renderer.
  switch (renderer) {
    case "cytoscape":
      return /*#__PURE__*/React.createElement("div", {
        style: {
          width: width,
          height: height
        }
      }, /*#__PURE__*/React.createElement(CytoScapeRenderer, {
        data: data,
        layout: layout,
        style: style,
        interactions: interactions,
        showNavigator: showNavigator,
        schema: schema,
        graphqlUrl: graphqlUrl,
        graphqlQuery: graphqlQuery
      }));

    case "react-force-graph":
      return /*#__PURE__*/React.createElement("div", {
        style: {
          width: width,
          height: height
        }
      }, /*#__PURE__*/React.createElement(ReactForceGraphRenderer, {
        data: data,
        layout: layout,
        style: style,
        interactions: interactions,
        showNavigator: false // react-force-graph doesn't support a navigator.
        ,
        schema: schema,
        graphqlUrl: graphqlUrl,
        graphqlQuery: graphqlQuery
      }));

    default:
      return /*#__PURE__*/React.createElement("div", null, "Invalid renderer specified.");
  }
};

export default GraphVisualization;