import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

/**
 * Formats our generic graph data representation into the format Cytoscape expects.
 */
export function formatData(data) {
  var _data = _slicedToArray(data, 2),
      nodes = _data[0],
      edges = _data[1];

  var elements = {
    nodes: [],
    edges: []
  };
  nodes.forEach(function (node) {
    var element = _objectSpread(_objectSpread({}, node), node["properties"]);

    delete element["properties"]; //@ts-ignore

    elements["nodes"].push({
      data: element,
      classes: "center-center"
    });
  });
  edges.forEach(function (edge) {
    var element = _objectSpread(_objectSpread({}, edge), edge["properties"]);

    delete element["properties"]; //@ts-ignore

    elements["edges"].push({
      data: element
    });
  }); // Deduplicate node array based on ID's

  elements["nodes"] = elements["nodes"].filter(function (v, i, a) {
    return a.findIndex(function (v2) {
      return v2.data.id === v.data.id;
    }) === i;
  });
  return elements;
}