"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CytoScapeRenderer = void 0;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _config = require("./config");

var _fetch = require("../../../util/fetch");

var _formatter = require("./formatter");

var _parser = require("../../../util/parser");

require("./style.css");

var _cytoscape = _interopRequireDefault(require("cytoscape"));

var _cytoscapeEuler = _interopRequireDefault(require("cytoscape-euler"));

var _cytoscapePopper = _interopRequireDefault(require("cytoscape-popper"));

var _cytoscapeDagre = _interopRequireDefault(require("cytoscape-dagre"));

require("cytoscape-navigator/cytoscape.js-navigator.css");

var _configMapper = require("./config-mapper");

var _reactCoolDimensions = _interopRequireDefault(require("react-cool-dimensions"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var navigator = require('cytoscape-navigator');

var CytoScapeRenderer = function CytoScapeRenderer(_ref) {
  var _ref$data = _ref.data,
      data = _ref$data === void 0 ? undefined : _ref$data,
      _ref$layout = _ref.layout,
      layout = _ref$layout === void 0 ? 'graph' : _ref$layout,
      _ref$style = _ref.style,
      style = _ref$style === void 0 ? {} : _ref$style,
      _ref$schema = _ref.schema,
      schema = _ref$schema === void 0 ? {} : _ref$schema,
      _ref$interactions = _ref.interactions,
      interactions = _ref$interactions === void 0 ? {} : _ref$interactions,
      _ref$showNavigator = _ref.showNavigator,
      showNavigator = _ref$showNavigator === void 0 ? false : _ref$showNavigator,
      graphqlUrl = _ref.graphqlUrl,
      graphqlQuery = _ref.graphqlQuery;

  var _useState = (0, _react.useState)(undefined),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      ref = _useState2[0],
      setRef = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      dataLoaded = _useState4[0],
      setDataLoaded = _useState4[1];

  var _useDimensions = (0, _reactCoolDimensions["default"])({
    onResize: function onResize(_ref2) {
      var observe = _ref2.observe,
          unobserve = _ref2.unobserve,
          width = _ref2.width,
          height = _ref2.height,
          entry = _ref2.entry;
      // Triggered whenever the size of the target is changed...
      unobserve(); // To stop observing the current target element

      // To stop observing the current target element
      observe(); // To re-start observing the current target element
    }
  }),
      observe = _useDimensions.observe,
      unobserve = _useDimensions.unobserve,
      width = _useDimensions.width,
      height = _useDimensions.height,
      entry = _useDimensions.entry;

  if (ref) {
    var cy = (0, _cytoscape["default"])({
      container: ref,
      style: getStyle(style)
    });

    _cytoscape["default"].use(_cytoscapeEuler["default"]);

    _cytoscape["default"].use(_cytoscapeDagre["default"]);

    _cytoscape["default"].use(_cytoscapePopper["default"]);

    if (data === undefined && graphqlQuery !== undefined && graphqlUrl !== undefined) {
      (0, _fetch.fetchGraphQLDataJSON)(graphqlUrl, graphqlQuery).then(function (_data) {
        setDataLoaded(true);
        var parsedData = (0, _parser.parseData)(_data, schema);
        var formattedData = (0, _formatter.formatData)(parsedData);
        var eles = cy.add(formattedData);
        cy.layout(_objectSpread(_objectSpread({}, _config.layoutSettings), {}, {
          name: _config.LAYOUT_NAMES[layout]
        })).run();
        cy.filter('node').forEach(function (t) {
          bindPopper(t);
        });
      });
    } else {
      if (dataLoaded == false) {
        setDataLoaded(true);
      }

      var parsedData = (0, _parser.parseData)(data, schema);
      var formattedData = (0, _formatter.formatData)(parsedData);
      var eles = cy.add(formattedData);
      cy.layout(_objectSpread(_objectSpread({}, _config.layoutSettings), {}, {
        name: _config.LAYOUT_NAMES[layout]
      })).run();
      cy.filter('node').forEach(function (t) {
        bindPopper(t);
      });
    }
    /**
     * Handles rendering the navigator window on the bottom right of the screen.
     */


    if (showNavigator) {
      _cytoscape["default"].use(navigator);

      var nav = cy.navigator(_config.navigatorSettings); // get navigator instance, nav
    } else {
      var div = document.getElementById("navigator");

      if (div) {
        div.innerHTML = '';
      }
    } //


    cy.on("click", "node", function (e) {
      return interactions && interactions.onNodeClick && interactions.onNodeClick(e.target._private.data);
    });
    cy.on("cxttap", "node", function (e) {
      return interactions && interactions.onNodeRightClick && interactions.onNodeRightClick(e.target._private.data);
    });
  }

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      width: 300,
      height: 200,
      position: 'absolute',
      right: 0,
      bottom: 0,
      overflow: 'hidden'
    },
    id: "navigator"
  }, " "), !dataLoaded ? /*#__PURE__*/_react["default"].createElement("div", null, "Loading...") : /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null), /*#__PURE__*/_react["default"].createElement("div", {
    id: "cy",
    ref: function ref(cyRef) {
      setRef(cyRef);
    },
    style: {
      width: "100%",
      height: "100%"
    }
  }, " "));
};

exports.CytoScapeRenderer = CytoScapeRenderer;

function getStyle(config) {
  return (0, _configMapper.mapConfig)(config);
}
/**
 *
 * @param target node or edge
 */


function bindPopper(target) {
  var tooltipId = "popper-target-".concat(target.id());
  var existingTarget = document.getElementById(tooltipId);

  if (existingTarget && existingTarget.length !== 0) {
    existingTarget.remove();
  }

  var popper = target.popper({
    content: function content() {
      // create div container
      var tooltip = document.createElement('div'); // adding id for easier JavaScript control

      tooltip.id = tooltipId; // adding class for easier CSS control

      tooltip.classList.add('target-popper'); // create actual table

      var table = document.createElement('table'); // append table to div container

      tooltip.append(table);
      var targetData = target.data(); // loop through target data

      for (var prop in targetData) {
        if (prop == "id") continue;
        if (!targetData.hasOwnProperty(prop)) continue;
        var targetValue = targetData[prop]; // no recursive or reduce support

        if ((0, _typeof2["default"])(targetValue) === "object") continue;
        var tr = table.insertRow();
        var tdTitle = tr.insertCell();
        var tdValue = tr.insertCell();
        tdTitle.innerText = prop;
        tdValue.innerText = targetValue;
      }

      document.body.appendChild(tooltip);
      return tooltip;
    }
  });
  target.on('position', function () {
    popper.update();
  });
  target.cy().on('pan zoom resize', function () {
    popper.update();
  });
  target.on('mouseover', function () {
    if (document.getElementById(tooltipId)) {
      document.getElementById(tooltipId).classList.add('active');
    }
  }).on('mouseout', function () {
    if (document.getElementById(tooltipId)) {
      document.getElementById(tooltipId).classList.remove('active');
    }
  });
}