"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mapConfig = mapConfig;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var NODE_SIZE_MULTIPLIER = 0.2;

function getOrDeriveValue(node, value) {
  if (value instanceof Function) {
    return value(node);
  }

  return value;
}
/**
 * For react-force-graph, assign styling properties directly to the elements to draw.
 */


function mapConfig(config, elements) {
  elements['nodes'] = elements['nodes'].map(function (node) {
    var nodeColor = config && config['nodeColor'] && config['nodeColor'][node.label] ? getOrDeriveValue(node, config['nodeColor'][node.label]) : "#aaa";
    var nodeSize = config && config['nodeSize'] && config['nodeSize'][node.label] ? getOrDeriveValue(node, config['nodeSize'][node.label]) * NODE_SIZE_MULTIPLIER : 4;
    return _objectSpread(_objectSpread({}, node), {}, {
      color: nodeColor,
      size: nodeSize
    });
  });
  return elements;
}