"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultConfig = exports.defaultArgs = exports.Template = void 0;

var _react = _interopRequireDefault(require("react"));

var _Graph = _interopRequireDefault(require("../component/graph/Graph"));

var _storybookAddonJsx = require("storybook-addon-jsx");

var _Graph2 = _interopRequireDefault(require("./Graph.mdx"));

/**
 * Configuration for all the graph visualization stories in the storybook.
 */
var defaultConfig = {
  component: _Graph["default"],
  parameters: {
    viewMode: 'story',
    options: {
      showPanel: true
    },
    docs: {
      page: _Graph2["default"]
    }
  },
  decorators: [_storybookAddonJsx.jsxDecorator],
  argTypes: {
    layout: {
      options: ['graph', 'tree'],
      control: {
        type: 'select'
      }
    },
    renderer: {
      options: ['cytoscape', 'react-force-graph'],
      control: {
        type: 'select'
      }
    }
  }
};
exports.defaultConfig = defaultConfig;
var defaultArgs = {
  renderer: 'cytoscape',
  layout: 'graph'
}; //👇 We create a “template” of how args map to rendering different variations of the visualization.

exports.defaultArgs = defaultArgs;

var Template = function Template(args) {
  return /*#__PURE__*/_react["default"].createElement(_Graph["default"], args);
};

exports.Template = Template;